Index: codes/icosagcm/trunk/src/dissip_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 357)
+++ codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 358)
@@ -111,5 +111,6 @@
       IF (is_master) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
    CASE DEFAULT
-      IF (is_master) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
+      IF (is_master) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), &
+        ' in dissip_gcm.f90/init_dissip'
       STOP
    END SELECT
Index: codes/icosagcm/trunk/src/domain.f90
===================================================================
--- codes/icosagcm/trunk/src/domain.f90	(revision 357)
+++ codes/icosagcm/trunk/src/domain.f90	(revision 358)
@@ -472,7 +472,7 @@
    
       ind_glo=0
-      WRITE(*,'')
+      PRINT *,''
       PRINT*, '      MPI PROCESS DISTRIBUTION'
-      WRITE(*,'')
+      PRINT *,''
       
       WRITE(*,"(' ')", ADVANCE='NO')
@@ -480,5 +480,5 @@
         WRITE(*,"('=')", ADVANCE='NO')
       ENDDO
-      WRITE(*,'')
+      PRINT *,''
 
       DO nf=1,nb_face
@@ -489,5 +489,5 @@
               WRITE(*,"('-')", ADVANCE='NO')
             ENDDO
-            WRITE(*,'')
+            PRINT *,''
           ENDIF
 
@@ -496,5 +496,5 @@
             WRITE(*,"(' ','    ',' |')",ADVANCE='NO')         
           ENDDO
-          WRITE(*,'')
+          PRINT *,''
 
           WRITE(*,"('|')", ADVANCE='NO')
@@ -503,5 +503,5 @@
             WRITE(*,"(' ',i4.4  ,' |')",ADVANCE='NO'),domglo_rank(ind_glo)           
           END DO
-          WRITE(*,'')
+          PRINT *,''
 
           WRITE(*,"('|')", ADVANCE='NO')
@@ -509,5 +509,5 @@
             WRITE(*,"(' ','    ',' |')",ADVANCE='NO')         
           ENDDO
-          WRITE(*,'')
+          PRINT *,''
 
         ENDDO
@@ -517,5 +517,5 @@
           WRITE(*,"('=')", ADVANCE='NO')
         ENDDO
-        WRITE(*,'')
+        PRINT *,''
       ENDDO
     ENDIF
Index: codes/icosagcm/trunk/src/restart.f90
===================================================================
--- codes/icosagcm/trunk/src/restart.f90	(revision 357)
+++ codes/icosagcm/trunk/src/restart.f90	(revision 358)
@@ -269,5 +269,6 @@
                 DO i=d%ii_begin,d%ii_end
                   DO k=0,5
-                   IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j .AND. d%edge_assign_pos(k,i,j)==k) THEN
+                   IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
+                     .AND. d%edge_assign_pos(k,i,j)==k) THEN
                        ij=(j-1)*d%iim+i
                       ind_glo=d%assign_cell_glo(i,j)
@@ -287,5 +288,6 @@
                 DO i=d%ii_begin,d%ii_end
                   DO k=0,5
-                   IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j .AND. d%edge_assign_pos(k,i,j)==k) THEN
+                   IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
+                     .AND. d%edge_assign_pos(k,i,j)==k) THEN
                        ij=(j-1)*d%iim+i
                       ind_glo=d%assign_cell_glo(i,j)
@@ -305,5 +307,6 @@
                 DO i=d%ii_begin,d%ii_end
                   DO k=0,5
-                    IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j .AND. d%edge_assign_pos(k,i,j)==k) THEN
+                    IF (d%edge_assign_domain(k,i,j)==ind .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j&
+                      .AND. d%edge_assign_pos(k,i,j)==k) THEN
                       ij=(j-1)*d%iim+i
                       ind_glo=d%assign_cell_glo(i,j)
Index: codes/icosagcm/trunk/src/transfert.F90
===================================================================
--- codes/icosagcm/trunk/src/transfert.F90	(revision 357)
+++ codes/icosagcm/trunk/src/transfert.F90	(revision 358)
@@ -3,14 +3,21 @@
 #ifdef CPP_USING_MPI
   USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_mpi, req_i1,req_e1_vect, &
-                                req_e1_scal, req_i0, req_e0_vect, req_e0_scal, request_add_point, create_request, gather_field, scatter_field, &
-                                t_message,init_message=>init_message_mpi,transfert_message=>transfert_message_mpi,  &
-                                send_message=>send_message_mpi,test_message=>test_message_mpi,wait_message=>wait_message_mpi,barrier, &
-                                bcast_mpi
+                                req_e1_scal, req_i0, req_e0_vect, req_e0_scal, request_add_point,             &
+                                create_request, gather_field, scatter_field,         &
+                                t_message, init_message=>init_message_mpi,           &
+                                transfert_message=>transfert_message_mpi,            &
+                                send_message=>send_message_mpi,                      &
+                                test_message=>test_message_mpi,                      &
+                                wait_message=>wait_message_mpi,barrier,bcast_mpi
 #else 
   USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_seq, req_i1,req_e1_vect, &
-                                req_e1_scal,req_i0, req_e0_vect, req_e0_scal, request_add_point, create_request, gather_field, scatter_field,&
-                                t_message,init_message=>init_message_seq,transfert_message=>transfert_message_seq,  &
-                                send_message=>send_message_seq,test_message=>test_message_seq,wait_message=>wait_message_seq,barrier, &
-                                bcast_mpi
+                                req_e1_scal,req_i0, req_e0_vect, req_e0_scal,        &
+                                request_add_point, create_request, gather_field,     &
+                                scatter_field, t_message,                            &
+                                init_message=>init_message_seq,                      &
+                                transfert_message=>transfert_message_seq,            &
+                                send_message=>send_message_seq,                      &
+                                test_message=>test_message_seq,                      &
+                                wait_message=>wait_message_seq,barrier, bcas_mpi
 #endif
 
Index: codes/icosagcm/trunk/src/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 357)
+++ codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 358)
@@ -1150,8 +1150,10 @@
               IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                 !$OMP CRITICAL            
-                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,               &
+                  send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                 !$OMP END CRITICAL
               ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                CALL MPI_ISEND(buffer_r,send%size,MPI_REAL8,send%rank,               &
+                  send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
               ENDIF
              
@@ -1186,8 +1188,10 @@
               IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                !$OMP CRITICAL            
-                CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,               &
+                  recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                !$OMP END CRITICAL
               ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                 CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                 CALL MPI_IRECV(buffer_r,recv%size,MPI_REAL8,recv%rank,              &
+                   recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
               ENDIF
             
@@ -1232,8 +1236,10 @@
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                   !$OMP CRITICAL   
-                  CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,        &
+                    send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                  CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_ISEND(buffer_r,send%size*dim3,MPI_REAL8,send%rank,        &
+                    send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                 ENDIF
               ENDIF
@@ -1274,8 +1280,10 @@
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                   !$OMP CRITICAL
-                  CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,        &
+                    recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                  CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_IRECV(buffer_r,recv%size*dim3,MPI_REAL8,recv%rank,        &
+                    recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                 ENDIF
               ENDIF
@@ -1307,5 +1315,6 @@
               CALL trace_start("copy_to_buffer")
               DO d4=1,dim4
-                offset=send%offset*dim3*dim4 + dim3*send%size*(d4-1) + (lbegin-1)*send%size
+                offset=send%offset*dim3*dim4 + dim3*send%size*(d4-1) +               &
+                  (lbegin-1)*send%size
 
                 DO d3=lbegin,lend
@@ -1321,8 +1330,10 @@
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                   !$OMP CRITICAL
-                  CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,   &
+                    send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                  CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+                  CALL MPI_ISEND(buffer_r,send%size*dim3*dim4,MPI_REAL8,send%rank,   &
+                    send%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
                 ENDIF
               ENDIF
@@ -1367,8 +1378,10 @@
                 IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) THEN
                  !$OMP CRITICAL           
-                  CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
+                  CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,   &
+                    recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
                   !$OMP END CRITICAL
                 ELSE IF (mpi_threading_mode==MPI_THREAD_MULTIPLE) THEN
-                  CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
+                  CALL MPI_IRECV(buffer_r,recv%size*dim3*dim4,MPI_REAL8,recv%rank,   &
+                    recv%tag+1000*message%number,comm_icosa, message%mpi_req(ireq),ierr) 
                 ENDIF
               ENDIF
@@ -1387,5 +1400,6 @@
           msize=message%buffers(ireq)%size
           rank=message%buffers(ireq)%rank
-          CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+          CALL MPI_ISEND(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+            comm_icosa, message%mpi_req(ireq),ierr)
         ENDDO
 
@@ -1394,5 +1408,6 @@
           msize=message%buffers(ireq)%size
           rank=message%buffers(ireq)%rank
-          CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,comm_icosa, message%mpi_req(ireq),ierr)
+          CALL MPI_IRECV(buffer_r,msize,MPI_REAL8,rank,1000*message%number,          &
+            comm_icosa, message%mpi_req(ireq),ierr)
         ENDDO
 
@@ -1413,5 +1428,6 @@
 
 !$OMP MASTER
-    IF (message%pending .AND. .NOT. message%completed) CALL MPI_TESTALL(message%nreq,message%mpi_req,message%completed,message%status,ierr)
+    IF (message%pending .AND. .NOT. message%completed) CALL MPI_TESTALL(message%nreq,&
+      message%mpi_req,message%completed,message%status,ierr)
 !$OMP END MASTER
   END SUBROUTINE  test_message_mpi
@@ -1456,5 +1472,6 @@
 
 !$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,          &
+          message%status,ierr)
 !$OMP END MASTER
 !$OMP BARRIER
@@ -1486,5 +1503,6 @@
 
 !$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,          &
+          message%status,ierr)
 !$OMP END MASTER
 !$OMP BARRIER
@@ -1534,5 +1552,6 @@
       ELSE  IF (field(1)%ndim==4) THEN
 !$OMP MASTER
-        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,          &
+          message%status,ierr)
 !$OMP END MASTER
 !$OMP BARRIER
@@ -1557,5 +1576,6 @@
               CALL trace_start("copy_from_buffer")
               DO d4=1,dim4
-                offset=recv%offset*dim3*dim4 + dim3*recv%size*(d4-1) + (lbegin-1)*recv%size
+                offset=recv%offset*dim3*dim4 + dim3*recv%size*(d4-1) +               &
+                  (lbegin-1)*recv%size
                 DO d3=lbegin,lend
                   DO n=1,recv%size
@@ -1624,13 +1644,16 @@
         IF (field(ind)%ndim==2) THEN
           DO n=1,req%size
-            rval2d(req%target_ind(n))=field(req%src_domain(n))%rval2d(req%src_ind(n))*req%target_sign(n)
+            rval2d(req%target_ind(n))=field(req%src_domain(n))%rval2d(req%src_ind(n))*&
+              req%target_sign(n)
           ENDDO
         ELSE IF (field(ind)%ndim==3) THEN
           DO n=1,req%size
-            rval3d(req%target_ind(n),:)=field(req%src_domain(n))%rval3d(req%src_ind(n),:)*req%target_sign(n)
+            rval3d(req%target_ind(n),:)=field(req%src_domain(n))%rval3d(req%src_ind(n),:)*&
+              req%target_sign(n)
           ENDDO
         ELSE IF (field(ind)%ndim==4) THEN
           DO n=1,req%size
-            rval4d(req%target_ind(n),:,:)=field(req%src_domain(n))%rval4d(req%src_ind(n),:,:)*req%target_sign(n)
+            rval4d(req%target_ind(n),:,:)=field(req%src_domain(n))%rval4d(req%src_ind(n),:,:)*&
+              req%target_sign(n)
           ENDDO
         ENDIF